#include <string>

using namespace std;

class Test {
   public:
/*! \brief A brief.

    This function declares one constant integer anonymously. However, Doxygen
	 thinks it is declaring a constant called "int". To be fair to Doxygen, this
	 is an ambiguity in C and C++. It would be great if Doxygen was able to
	 correctly resolve the ambiguity, though. The ambiguity affects Doxygen
	 because the parameter is impossible to document properly. For example:
    \param[in] Do I do it like this?
    \param[in] const int Or like this?
    \param[in] int This renders correctly but just feels wrong.
    \param[in] bob Now this is just silly.
*/
      void my_func(const int);
/*! \brief Nothing wrong here.

    This function declares a variable pointer to a constant integer.
*/
      void my_fu_2(const int *);
/*! \brief A brief.

    This function declares a constant pointer to a variable integer. Here we see
    another ambiguity manifest. Doxygen thinks the declaration is that of a
    pointer to an integer named "const".
    \param const The problem is the same as for \c Test::my_func().
*/
      void my_fu_3(int * const);
};

void Test::my_func(const int a) {
   (void)a; // Stop the compiler complaining about unused variables.
}

void Test::my_fu_2(const int *a) {
   (void)a; // Stop the compiler complaining about unused variables.
}

void Test::my_fu_3(int * const a) {
   (void)a; // Stop the compiler complaining about unused variables.
}

int main(int, char**) {
   return 0;
}
